//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Discovery
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Get Feature Definition command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class GetFeatureDefinitionRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _featureIdentifier;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public GetFeatureDefinitionRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="featureIdentifier">
        ///        The fully qualified Feature identifier for which the Feature definition shall be retrieved.
        ///      </param>
        public GetFeatureDefinitionRequestDto(string featureIdentifier, Tecan.Sila2.IBinaryStore store)
        {
            FeatureIdentifier = new Tecan.Sila2.StringDto(featureIdentifier, store);
        }
        
        /// <summary>
        /// The fully qualified Feature identifier for which the Feature definition shall be retrieved.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto FeatureIdentifier
        {
            get
            {
                return _featureIdentifier;
            }
            set
            {
                _featureIdentifier = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/SiLAService/v1/Command/GetFeatureDefinition";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(FeatureIdentifier, "featureIdentifier");
            if ((IdentifierConstraint.IsValid(FeatureIdentifier.Value, Tecan.Sila2.IdentifierType.FeatureIdentifier) == false))
            {
                throw new ArgumentException(string.Format("FeatureIdentifier \'{0}\' is not a valid FeatureIdentifier", FeatureIdentifier.Value), "featureIdentifier");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(FeatureIdentifier, "featureIdentifier"));
            if ((IdentifierConstraint.IsValid(FeatureIdentifier.Value, Tecan.Sila2.IdentifierType.FeatureIdentifier) == false))
            {
                errors = (errors + string.Format("FeatureIdentifier \'{0}\' is not a valid FeatureIdentifier", FeatureIdentifier.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Get Feature Definition command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class GetFeatureDefinitionResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _featureDefinition;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public GetFeatureDefinitionResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="featureDefinition">The Feature definition in XML format (according to the Feature Definition Schema).</param>
        public GetFeatureDefinitionResponseDto(string featureDefinition, Tecan.Sila2.IBinaryStore store)
        {
            FeatureDefinition = new Tecan.Sila2.StringDto(featureDefinition, store);
        }
        
        /// <summary>
        /// The Feature definition in XML format (according to the Feature Definition Schema).
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto FeatureDefinition
        {
            get
            {
                return _featureDefinition;
            }
            set
            {
                _featureDefinition = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(FeatureDefinition, "featureDefinition");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(FeatureDefinition, "featureDefinition"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Set Server Name command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SetServerNameRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _serverName;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public SetServerNameRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="serverName">The human readable name to assign to the SiLA Server.</param>
        public SetServerNameRequestDto(string serverName, Tecan.Sila2.IBinaryStore store)
        {
            ServerName = new Tecan.Sila2.StringDto(serverName, store);
        }
        
        /// <summary>
        /// The human readable name to assign to the SiLA Server.
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto ServerName
        {
            get
            {
                return _serverName;
            }
            set
            {
                _serverName = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/core/SiLAService/v1/Command/SetServerName";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(ServerName, "serverName");
            if ((ServerName.Value.Length > 255))
            {
                throw new ArgumentException(string.Format("ServerName  has length {0} and is longer than allowed length 255", ServerName.Value.Length), "serverName");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(ServerName, "serverName"));
            if ((ServerName.Value.Length > 255))
            {
                errors = (errors + string.Format("ServerName  has length {0} and is longer than allowed length 255", ServerName.Value.Length));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Server Name property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ServerNameResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ServerNameResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ServerNameResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((Value.Value.Length > 255))
            {
                throw new ArgumentException(string.Format("Value  has length {0} and is longer than allowed length 255", Value.Value.Length), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((Value.Value.Length > 255))
            {
                errors = (errors + string.Format("Value  has length {0} and is longer than allowed length 255", Value.Value.Length));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Server Type property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ServerTypeResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ServerTypeResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ServerTypeResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((RegexConstraint.IsMatch(Value.Value, "[A-Z][a-zA-Z0-9]*") == false))
            {
                throw new ArgumentException(string.Format("Value \'{0}\' does not match pattern \'[A-Z][a-zA-Z0-9]*\'", Value.Value), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((RegexConstraint.IsMatch(Value.Value, "[A-Z][a-zA-Z0-9]*") == false))
            {
                errors = (errors + string.Format("Value \'{0}\' does not match pattern \'[A-Z][a-zA-Z0-9]*\'", Value.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Server UUID property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ServerUUIDResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ServerUUIDResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ServerUUIDResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((Value.Value.Length != 36))
            {
                throw new ArgumentException(string.Format("Value has length {0} but should have been 36", Value.Value.Length), "value");
            }
            if ((RegexConstraint.IsMatch(Value.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                throw new ArgumentException(string.Format("Value \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-" +
                            "f]{4}\\-[0-9a-f]{12}\'", Value.Value), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((Value.Value.Length != 36))
            {
                errors = (errors + string.Format("Value has length {0} but should have been 36", Value.Value.Length));
            }
            if ((RegexConstraint.IsMatch(Value.Value, "[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}") == false))
            {
                errors = (errors + string.Format("Value \'{0}\' does not match pattern \'[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-" +
                        "f]{4}\\-[0-9a-f]{12}\'", Value.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Server Version property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ServerVersionResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ServerVersionResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ServerVersionResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((RegexConstraint.IsMatch(Value.Value, "(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\.(0|[1-9][0-9]*))?(_[_a-zA-Z0-9]+)?") == false))
            {
                throw new ArgumentException(string.Format("Value \'{0}\' does not match pattern \'(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\.(0|[1-9][0" +
                            "-9]*))?(_[_a-zA-Z0-9]+)?\'", Value.Value), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((RegexConstraint.IsMatch(Value.Value, "(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\.(0|[1-9][0-9]*))?(_[_a-zA-Z0-9]+)?") == false))
            {
                errors = (errors + string.Format("Value \'{0}\' does not match pattern \'(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\.(0|[1-9][0" +
                        "-9]*))?(_[_a-zA-Z0-9]+)?\'", Value.Value));
            }
            return errors;
        }
    }
    
    /// <summary>
    /// Data transfer object to encapsulate the response of the Server Vendor URL property
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ServerVendorURLResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _value;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ServerVendorURLResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public ServerVendorURLResponseDto(string value, Tecan.Sila2.IBinaryStore store)
        {
            Value = new Tecan.Sila2.StringDto(value, store);
        }
        
        /// <summary>
        /// The  property
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Value, "value");
            if ((RegexConstraint.IsMatch(Value.Value, "https?://.+") == false))
            {
                throw new ArgumentException(string.Format("Value \'{0}\' does not match pattern \'https?://.+\'", Value.Value), "value");
            }
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = ("" + Argument.Require(Value, "value"));
            if ((RegexConstraint.IsMatch(Value.Value, "https?://.+") == false))
            {
                errors = (errors + string.Format("Value \'{0}\' does not match pattern \'https?://.+\'", Value.Value));
            }
            return errors;
        }
    }
}
